config/routes.rb
Rails.application.routes.draw do
  devise_for :users

  root 'welcome#index'

  resources :task_lists do
    resources :todos do
      member do
        put ':id', to: 'todos#update', as: 'update'
      end
    end
  end

  namespace :api do
    resources :task_lists, formats: [:json] do
      resources :todos
    end
  end

end

app/models/task_list.rb
class TaskList < ActiveRecord::Base
	include TaskListable
  has_many :todos
  belongs_to :user
  accepts_nested_attributes_for :todos, allow_destroy: true

  validates_presence_of :user_id
  validates_presence_of :name
end

app/controllers/api/task_lists_controller.rb
class Api::TaskListsController < Api::BaseController
  before_action :find_task, only: [:update, :show, :destroy]

  ## GET api/task_lists/index

  # api :GET, 'api/task_lists/index', 'Get users task_lists'
  # formats ['json']
  def index
    @tasks = TaskList.where(user_id: @current_user.id)
    render template: 'task_lists/index', format: :json
  end

  ## GET api/task_lists/:id

  # api :GET, 'api/task_lists/:id', 'Get details of a task_list'
  # param :direction, String, desc: 'search query string', required: false
  # param :sort, String, desc: 'search query string', required: false
  # formats ['json']
  def show
    @todos = @task.ordered_todos(sort_column, sort_direction)
    render template: 'task_lists/show', format: :json
  end

  ## PUT api/task_lists/:id
  # api :PUT, 'api/task_lists/:id', 'Update a task_list'

  # param :name, String, desc: 'Task List name', required: true
  # param :todo_attributes, Hash, desc: 'todo object' do
  #   param :description, String, desc: 'Todo description', required: true
  #   param :due_date, String, desc: "Due date with format mm/dd/yyyy", required: false
  # end
  # formats ['json']
  def update
    if @task.update(allowed_update_params) && @task.reload
      render template: 'task_lists/show', format: :json
    else
      render json: @task.errors, status: :unprocessable_entity
    end
  end

  # DELETE api/task_lists/:id

  # api :DELETE, 'api/task_lists/:id', 'Delete a task_list'
  # formats ['json']
  def destroy
    if @task.destroy
      render json: {message: 'Task successuflly deleted'}, format: :json
    else
      render json: @task.errors, status: :unprocessable_entity
    end
  end

  private

  def task_params
    params.require(:task_list).permit(:name,
      todos_attributes: [:id, :description,
        :completed, :priority,
        :_destroy, :task_list_id,
        :due_date])
  end

  def allowed_update_params
    params.require(:task_list).permit(:name,
      todos_attributes: [:id, :description, :completed, :priority, :due_date])
  end

  def find_task
    @task = TaskList.find_by(id: params[:id], user_id: @current_user.id)
    unless @task.present?
      render json: {message: 'Task not found'}, status: :unprocessable_entity
    end
  end
end

app/controllers/task_lists_controller.rb
class TaskListsController < ApplicationController
  before_action :find_task, only: [:edit, :update, :show, :destroy]

  # GET /task_lists
  def index
    @tasks = current_user.task_lists
  end

  # GET /task_lists/:id
  def show
    @todos = @task.ordered_todos(sort_column,sort_direction)
  end

  # GET /task_lists/new
  def new
    @task = TaskList.new
    @task.todos.build
  end

  # GET /task_lists/:id/edit
  def edit
    @task = TaskList.find_by(id: params[:id])
    @todos = @task.ordered_todos(sort_column,sort_direction)
    render template: 'task_lists/show', format: :html
  end

  # PUT /task_lists/:id
  def update
    respond_to do |format|
      if @task.update(task_params)
        format.html { redirect_to action: "show", notice: 'Task was successfully updated.'}
        format.json { render :show, status: :created, location: @task }
      else
        format.html { render :edit }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # POST /task_lists
  def create
    @task = current_user.task_lists.new(name: params[:task_list][:name])
    respond_to do |format|
      if @task.save
        format.html { redirect_to action: "index", notice: 'Task was successfully created.' }
        format.json { render :show, status: :created, location: @task }
      else
        format.html { render :new }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /task_lists/:id
  def destroy
    respond_to do |format|
      if @task.destroy
        format.html { redirect_to action: "index", notice: 'Task was successfully deleted.' }
        format.json { render :index, status: :created, location: @task }
      else
        format.html { render :index }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  private

  def task_params
    params.require(:task_list).permit(:name, :priority,
      todos_attributes: [:id, :description,
        :completed, :priority,
        :_destroy, :task_list_id,
        :due_date])
  end

  def find_task
    @task = TaskList.find_by(id: params[:id])
  end
end

app/views/task_lists/_form.html.erb
<%= form_for(@task) do |f| %>
	<% if @task.errors.any? %>
		<div id="error_explanation">
		  <h2><%= pluralize(@task.errors.count, "error") %> prohibited this task from being saved:</h2>

		  <ul>
		  <% @task.errors.full_messages.each do |message| %>
		    <li><%= message %></li>
		  <% end %>
		  </ul>
		</div>
	<% end %>

	<div class="field">
		<%= f.label :name %><br>
		<%= f.text_field :name %>
	</div>
	<div class="actions">
		<%= f.submit %>
	</div>
<% end %>

app/views/task_lists/edit.html.erb
<%= link_to 'Back', task_lists_path %>
<%= link_to('Logout', destroy_user_session_path, method: :delete) %>
<h2> Edit task <%= @task.name %> </h2>
<%= link_to 'New Todo', new_task_list_todo_path(task_list_id: @task.id) %>
<br/>
<%= form_for @task do |f| %>
  <%= f.label :name %>
  <%= f.text_field :name %>
  <br/>
  <table>
    <%= f.fields_for :todos do |builder| %>
      <% if builder.object.id? %>
        <div class="task-list-todo", id="todo-<%= builder.object.id%>">
          <%= builder.check_box :completed %>
          <%= builder.text_field :description %>
          <%= builder.number_field :priority %>
          Delete? <%= builder.check_box :_destroy%>
        </div>
      <% end %>
      <br/>
    <% end %>
  </table>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/task_lists/index.html.erb
<%= link_to 'Back', task_lists_path %>
<%= link_to('Logout', destroy_user_session_path, method: :delete) %>
<div>
  <%= link_to 'New Task', new_task_list_path %>
  <% if @tasks.present? %>
  <table>
    <th>Task Name</th>
    <th>Completion %</th>
    <th></th>
    <% @tasks.each do |list| %>
      <tr>
        <td><%= list.name %></td>
        <td><%= list.completion_percentage*100 %></td>
        <td><%= link_to 'Edit', edit_task_list_path(list)%></td>
        <td><%= link_to 'Delete', task_list_path(list), method: :delete%></td>
      </tr>
    <% end %>
  </table>
  <% else %>
    <span>No tasks to show.</span>
  <% end %>
</div>

app/views/task_lists/new.html.erb
<%= link_to 'Back', task_lists_path %>
<%= link_to('Logout', destroy_user_session_path, method: :delete) %>
<h1>New Todo</h1>

<%= render 'form' %>

app/views/task_lists/show.html.erb
<%= link_to 'Back', task_lists_path %>
<%= link_to('Logout', destroy_user_session_path, method: :delete) %>
<h2> Edit task <%= @task.name %> </h2>
<%= link_to 'New Todo', new_task_list_todo_path(task_list_id: @task.id) %>
<br/>
<%= render template: 'todo/index' %>